<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo M2<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>JAIME JIMENO MARTÍN</p>
            <p>JULIO CÉSAR RAMÍREZ ORÉ</p>
            <p>ESTELA MONZÓN FRASQUET</p>
            <p>FRANCISCO GARCÍA-MORALES HURTADO</p>
            <p>DANIEL BOYANO GONZÁLEZ </p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
				<a href="https://gitlab.com/dte2020/m2_/tg3/">https://gitlab.com/dte2020/m2_/tg3/</a>
			<h3>1.3 Burndown chart</h3>
			<img src="burndownTG3.jpg">
			<h3>1.4 Presentacion del trabajo</h3>
			<a href="tg3.pptx">Presentacion con diapositivas del trabajo TG3</a></p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>

			<h3>2.1 Catálogo de requisitos</h3>
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripción</th>
				</tr>
				<tr>
					<td>01</td>
					<td>La aplicación debe coordinar el almacenamiento de información persistente</td>
				</tr>
				<tr>
					<td>02</td>
					<td>La aplicación debe trabajar con una base de datos SQL</td>
				</tr>
				<tr>
					<td>03</td>
					<td>La aplicación debe almacenar la infomación en la base de datos de la manera más 								eficiente posible</td>
				</tr>
				<tr>
					<td>04</td>
					<td>La información deberá estar correctamente estructurada en las tablas pertinentes</td>
				</tr>
				<tr>
					<td>05</td>
					<td>La app debe aportar la información requerida en las posibles consultas realizas</td>	
				</tr>
				<tr>
					<td>06</td>
					<td>El lenguaje usado en la app debe ser JAVA</td>
				</tr>
				<tr>
					<td>07</td>
					<td>Se debe garantizar la persistencia de datos, es decir, 
						su seguridad en caso de pérdida</td>
				</tr>
				<tr>
					<td>08</td>
					<td>La persistencia debe ser configurada con XML</td>
				</tr>
				<tr>
					<td>09</td>
					<td>Los parámetros de conexión deben estar alamacenados en un archivo de propiedades</td>
				</tr>
				<tr>
					<td>10</td>
					<td>El bean (objetos encapsulados) deben estar en un único paquete</td>
				</tr>
				<tr>
					<td>11</td>
					<td>La app crea y asigna objetos de diversas clases para su consulta posterior</td>
				</tr>
			</table>
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos</h2>
			
			<h3>3.1 Criterio 1: Tiempo de desarrollo</h3>
			<ul>
				<li>Nombre del criterio: Tiempo de desarrollo</li>
				<li>Descripcion: Tiempo total utilizado para crear el prototipo</li>
				<li>Tipo de valor: Numérico (horas).</li>
			</ul>
			
			<h3>3.2 Criterio 2: Cantidad de líneas de código</h4>
				<ul>
					<li>Nombre del criterio: Cantidad de líneas de código</li>
					<li>Descripcion: Número de líneas de código escritas por los desarrolladores</li>
					<li>Tipo de valor: Numérico</li>
				</ul>
			
			<h3>3.3 Criterio 3: Número de herramientas utilizadas</h4>
				<ul>
					<li>Nombre del criterio: Numero de herramientas utilizadas</li>
					<li>Descripcion: Cantidad de herramientas utilizadas por los desarrolladores para crear el prototipo</li>
					<li>Tipo de valor: Numérico</li>
				</ul>
			
			<h3>3.4 Criterio 4: Nivel de dificultad de desarrollo</h4>
				<ul>
					<li>Nombre del criterio: Nivel de dificultad de desarrollo</li>
					<li>Descripcion: Cuanta dificultad han superado los desarrolladores</li>
					<li>Tipo de valor: Texto</li>
				</ul>
				
			<h3>3.5 Criterio 5: Tiempo de aprendizaje</h4>
				<ul>
					<li>Nombre del criterio: Tiempo de aprendizaje</li>
					<li>Descripcion: Tiempo utilizado para familiarizarse con los entornos de desarrollo</li>
					<li>Tipo de valor: Numérico (horas)</li>
				</ul>

			<h3>3.6 Criterio 6: Recursos utilizados para el entendimiento de las herramientas</h4>
				<ul>
					<li>Nombre del criterio: Recursos utilizados para el entendimiento de las herramientas</li>
					<li>Descripcion: Qué recursos se han utilizado para comprender la utilización de las herramientas</li>
					<li>Tipo de valor: Texto</li>
				</ul>
				
	<section id="4">
			<h2>4. Implementación del prototipo con tecnología A</h2>
			<p>
				<a
					href="https://gitlab.com/dte2020/m2_/tg3/-/tree/master/prototipo-A/">https://gitlab.com/dte2020/m2/tg3/-/tree/master/prototipo-A/</a>.
			</p>
			<p>En la carpeta se encuentra el proyecto Maven de Java(habiendo usado Eclipse), utilizando la base de datos h2, la cual está incluida en el proyecto (se crea en memoria, si se quisiera guardar en disco, se debería cambiar la URL). El main es PruebaEmpleados.java, por lo que cualquier modificación se debería hacer en este mismo. Si se desea cambiar la estructura de la base de datos, es conveniente ver primero la forma de implementación de la actual, con el fin de comprender las anotaciones usadas por Hibernate.
			</p>
			<h3>4.1 Planteamiento del prototipo</h4>
			<p>Hibernate es una herramienta de mapeo objeto-relacional que agiliza la relación entre Java y la base de datos SQL, esto significa que es donde Java volcará los modelos de objetos programados anteriormente para convertirlos en tablas, lo que es necesario para crear una base de datos. mediante archivos declarativos (XML) o anotaciones en los beans de las entidades que permiten establecer estas relaciones. 
				Lo que al final conseguimos con esta tecnología es agilizar las relaciones entre la app y la base de datos, evitando, entre otras cosas, caer en código repetitivo. 
				Hibernate permite manejar la base de datos utilizando todas las características de la POO en Java mientras genera las sentencias SQL que sí entienden las bases de datos. 
				Para poder utilizarlo, es necesario tener conocimientos sobre programación en Java, bases de datos y lenguaje SQL.

			</p>
			<h3>4.2 Documentación</h4>
			<p>La documentación que hemos seguido para realizar la implementación del prototipo con la tecnología A es la siguiente:
			Videos tutoriales en la plataforma YouTube: <i>Java: JPA + Hibernate</i> --> 
			<a
				href= "https://www.youtube.com/watch?v=qM9cuqvT_jI&feature=youtu.be"/>https://www.youtube.com/watch?v=qM9cuqvT_jI&feature=youtu.be</a>
			</p>
			
		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con tecnología B</h2>
			<p>
				<a
					href="https://gitlab.com/dte2020/m2_/tg3/-/tree/master/prototipo-B/">https://gitlab.com/dte2020/m2/tg3/-/tree/master/prototipo-B/</a>.
			</p>
			<p>En la carpeta podemos encontrar un codigo desarrollado en Eclipse (App) y una base de datos creada con Oracle 12c. Para poder ejecutar el prototipo lo primero que tenemos que hacer es crear la base de datos desde SQL Plus y despues cargarla, una vez realizado esto tendremos que ir a Eclipse para importar la carpeta App y ejecutar Prueba01.java.</p>
			<h3>5.1 Planteamiento del prototipo</h4>
			<p>MyBatis es un framework de persistencia de Java que soporta SQL.
			Este framework simplifica la programación. MyBatis puede configurarse con XML.
			MyBatis es software libre y se ha desarrollado bajo Licencia Apache 2.0
			Es una bifurcación de iBATIS 3.0 y es mantenido por un equipo que incluye a los creadores originales de iBATIS.
			La función de este software es asociar objetos de modelo con sentencias SQL (escritas por el administrador), lo que facilitará la utilización de la BBDD. iBatis incluye como componentes:
				- Data Mapper: interacción de datos entre objetos JAVA y la BBDD.
				- Data Access Object: oculta la persistencia de objetos y proporciona        API de acceso a datos.

			</p>
			<h3>5.2 Documentación</h4>
			<p>La documentación que hemos seguido para realizar la implementación del prototipo con la tecnología B es la siguiente:
			Videos tutoriales en la plataforma YouTube: <i>MyBatis Framework Ejemplo Práctico</i> -->

			<a 
			href= "https://www.youtube.com/watch?v=iutPdvTLZW8"/>https://www.youtube.com/watch?v=iutPdvTLZW8&feature=youtu.be</a>
			</p>
		</section>
		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
			
			<table>
				<tr>
					<th>Criterio</th>
					<th>Prototipo A</th>
					<th>Prototipo B</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Tiempo de desarrollo</td>
					<td>5 horas</td>
					<td>6 horas</td>
					<td>Observamos que la tecnología B requiere de más tiempo para su desarrollo, debido al tipo de configuración de la base de datos y la conexión a realizar entre Java y la base de datos.</td>
				</tr>
				<tr>
					<td>Cantidad de líneas de código</td>
					<td>316</td>
					<td>280</td>
					<td>En este caso la tecnología A ha necesitado más líneas de código para su programación.</td>
				</tr>
				
				<tr>
					<td>Número de herramientas utilizadas</td>
					<td>2</td>
					<td>3</td>
					<td>Para la tecnología A se ha utilizado Eclipse y H2. Para la tecnología B se ha utilizado Eclipse, Oracle 12c y Notepad++.</td>
				</tr>
				
				<tr>
					<td>Nivel de dificultad de desarrollo</td>
					<td>Fácil. Después de haber consultado los recursos sobre la herramienta, ha resultado fácil implementar el prototipo. Hemos encontrado dos dificultades: 1. Realizar las consultas HQL. 2. Introducir bien los parámetros en el Persistance.</td>
					<td>Medio. La mayor dificultad encontrada es que los recursos a consultar están un tanto desactualizados.</td>
					<td>Debido a que Hibernate se utiliza mucho más que iBatis, es más facil también encontrar información actualizada y relevante.</td>
				</tr>
				
				<tr>
					<td>Tiempo de aprendizaje</td>
					<td>2 horas</td>
					<td>3 horas</td>
					<td>Existe menos información sobre iBatis, por lo que hay que invertir mas tiempo en familiarizarse con el entorno.</td>
				</tr>
				
				<tr>
					<td>Recursos utilizados para el entendimiento de las herramientas</td>
					<td>La serie de vídeotutoriales de YouTube llamada "Java: JPA + Hibernate", subido por el usuario con nombre: "makigas"</td>
					<td>El video de YouTube llamado: "Primeros pasos con MyBatis", subido por el usuario con nombre: "Desarrolla Software" y el blog http://gcoronelc.blogspot.com/2014/11/creacion-del-esquema-eureka</td>
					<td>Este tipo de videotutorales facilitan mucho el aprendizaje de la herramienta, ya que explican sus bases desde cero, que es lo que necesitamos para un prototipo.</td>
				</tr>
				
			</table>
		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>Si bien es cierto que Hibernate es más utilizado actualmente que iBatis cabe decir que, si se busca un "ganador" en aspectos generales, no es posible encontrarlo. Es necesario especificar situaciones para saber cual
			de las dos herramientas puede proporcionar mas ventajas. Las situaciones son:</p>
			
		<ul>
			
			<li>1. Si queremos centrarnos en los objetos, eligiremos Hibernate.</li>
			<li>2. Si queremos centrarnos en la base de datos, eligiremos iBatis.</li>
			<li>3. Si se trata de una base de datos heredada en la que tenemos que realizar consultas SQL complicadas, eligiremos iBatis. Con Hibernate, necesitas aprender también HQL y tener la combinacion correcta de XML
			para realizar una consulta eficaz.</li>
			<li>4. Si queremos un aprendizaje rápido, lo mejor será iBatis ya que es más fácil entender lo que ocurre en cada proceso. La curva de aprendizaje de Hibernate es mayor.</li>
			<li>5. Si eres un programador poco familiarizado con SQL, Hibernate será más facil de utilizar ya que no tiene que escribir las consultas manualmente.</li>
			<li>6. Si tienes el control sobre la aplicación y la base datos, con Hibernate puedes modificar la aplicación para adaptarla a la base de datos, o viceversa.</li>
			
		</ul>
			
			<p>Como podemos ver, existen varias situaciones y según en la que te encuentres, has de elegir una de las dos tecnologías, aunque esta claro que la diferencia principal es que Hibernate es un ORM e iBatis no, por
			lo que la decisión dependerá principalmente de si queremos un mapeo objeto-relacional o asociar objetos de modelo con sentencias SQL.</p>
		</section>

		

	</main>

</body>

</html>
